From 5d5e76d369a412bfb3d2cebb5fc0a7509cef878d Mon Sep 17 00:00:00 2001
From: Rod Smith <rodsmith@rodsbooks.com>
Date: Fri, 15 Apr 2022 18:10:14 -0400
Subject: [PATCH 1/2] Fix failure & crash of sgdisk when compiled with latest
 popt (commit 740; presumably eventually release 1.19)

---
 NEWS      | 8 ++++++++
 gptcl.cc  | 2 +-
 support.h | 2 +-
 3 files changed, 10 insertions(+), 2 deletions(-)

diff --git a/NEWS b/NEWS
index c7add563bab2..9e153fd73b3b 100644
--- a/NEWS
+++ b/NEWS
@@ -1,3 +1,11 @@
+1.0.10 (?/??/2022):
+-------------------
+
+- Fixed problem that caused sgdisk to crash with errors about being unable
+  to read the disk's partition table when compiled with the latest popt
+  (commit 740, which is pre-release as I type; presumably version 1.19 and
+  later once released).
+
 1.0.9 (4/14/2022):
 ------------------
 
diff --git a/gptcl.cc b/gptcl.cc
index 34c942100842..0d578ebf0034 100644
--- a/gptcl.cc
+++ b/gptcl.cc
@@ -155,7 +155,7 @@ int GPTDataCL::DoOptions(int argc, char* argv[]) {
    } // while
 
    // Assume first non-option argument is the device filename....
-   device = (char*) poptGetArg(poptCon);
+   device = strdup((char*) poptGetArg(poptCon));
    poptResetContext(poptCon);
 
    if (device != NULL) {
diff --git a/support.h b/support.h
index 8ba9ad1aa896..f91f1bc8b1ed 100644
--- a/support.h
+++ b/support.h
@@ -8,7 +8,7 @@
 #include <stdlib.h>
 #include <string>
 
-#define GPTFDISK_VERSION "1.0.9"
+#define GPTFDISK_VERSION "1.0.9.1"
 
 #if defined (__FreeBSD__) || defined (__FreeBSD_kernel__) || defined (__APPLE__)
 // Darwin (Mac OS) & FreeBSD: disk IOCTLs are different, and there is no lseek64
-- 
2.35.1

